//ANUBIS! - King Of The Underworld

/* CVARS - copy and paste to shconfig.cfg

//Anubis
anubis_level 0
anibus_showdamage 1		//(0|1) - hide|show bullet damage..
anibus_showchat 1		//(0|1) - hide|show ghostchat messages..

*/

/*
*   v1.17 - JTP10181
*	- Added ablily to disable the ghostchat like function
*		for servers that already have ghostchat
*/

#include <amxmodx>
#include <engine>
#include <cstrike>
#include <shero>

// GLOBAL VARIABLES
new g_heroName[]="Anubis"
new g_heroID
new bool:g_hasAnubis[SH_MAXSLOTS+1]
new g_msgSayText
//----------------------------------------------------------------------------------------------
public plugin_init()
{
	// Plugin Info
	register_plugin("SUPERHERO Anubis", "2.0", "AssKicR/JTP10181")

	// DO NOT EDIT THIS FILE TO CHANGE CVARS, USE THE SHCONFIG.CFG
	register_cvar("anubis_level", "0")
	register_cvar("anibus_showdamage", "1")
	register_cvar("anibus_showchat", "1")

	// FIRE THE EVENT TO CREATE THIS SUPERHERO!
	g_heroID = sh_create_hero(g_heroName)
	sh_hero_info(g_heroID, "Dark Notices", "Nothing Is Secret From You. Hear Enemies - See Damage")
	sh_hero_bind(g_heroID, false)
	sh_hero_level(g_heroID, get_cvar_num("anubis_level"))

	// REGISTER EVENTS THIS HERO WILL RESPOND TO! (AND SERVER COMMANDS)
	// DAMAGE EVENT
	register_event("Damage", "damage_msg", "b", "2!0", "3=0", "4!0")

	// Say
	register_clcmd("say", "handle_say")
	register_clcmd("say_team", "handle_say")

	g_msgSayText = get_user_msgid("SayText")
}
//----------------------------------------------------------------------------------------------
public sh_hero_init(id, heroID, mode)
{
	// See if this hero is the same that's being init
	if ( g_heroID == heroID )
	{
		switch(mode)
		{
			case HERO_ADD:
			{
				g_hasAnubis[id] = true
				anubis_speak_on(id)
			}
			case HERO_DROP:
			{
				g_hasAnubis[id] = false
				anubis_speak_off(id)
			}
		}
	}
}
//----------------------------------------------------------------------------------------------
public sh_new_spawn(id)
{
	if ( is_user_alive(id) && g_hasAnubis[id] )
		anubis_speak_on(id)
}
//----------------------------------------------------------------------------------------------
public handle_say(id)
{
	if ( !sh_server_info(SH_MODACTIVE) || !get_cvar_num("anibus_showchat") )
		return

	new message[191]
	read_argv(1, message, 190)

	if ( equal(message, "") || equal(message, "[") )
		return

	new command[10], players[SH_MAXSLOTS], player_count, user
	new teamname[5], idName[33], sMessage[191]

	read_argv(0, command, 16)
	new idSayTeam = equal(command, "say_team")

	new idAlive = is_user_alive(id)
	new CsTeams:idTeam = cs_get_user_team(id)

	switch(idTeam)
	{
		case CS_TEAM_T:
			copy(teamname, 4, "(T)")
		case CS_TEAM_CT:
			copy(teamname, 4, "(CT)")
	}

	get_user_name(id, idName, 32)

	format(sMessage, 190, "%c[DN]%s%s%s :  %s^n", 2,  idSayTeam ? teamname : "", idAlive ? "*ALIVE*" : "*DEAD*", idName, message)

	// Get all players but skip bots
	get_players(players, player_count, "c")

	for ( new i = 0; i < player_count; i++ )
	{
		user = players[i]

		if ( g_hasAnubis[user] && is_user_connected(user) )
		{
			if ( is_user_alive(user) && !idAlive || idSayTeam && idTeam != cs_get_user_team(user) )
			{
				message_begin(MSG_ONE_UNRELIABLE, g_msgSayText, {0,0,0}, user)
				write_byte(id)
				write_string(sMessage)
				message_end()
			}
		}
	}
}
//----------------------------------------------------------------------------------------------
public anubis_speak_on(id)
{
	if ( g_hasAnubis[id] && is_user_connected(id) )
		set_speak(id, SPEAK_LISTENALL)
}
//----------------------------------------------------------------------------------------------
public anubis_speak_off(id)
{
	if ( !g_hasAnubis[id] && is_user_connected(id) )
		set_speak(id, SPEAK_NORMAL)
}
//----------------------------------------------------------------------------------------------
public damage_msg(vIndex)
{
	if ( !sh_server_info(SH_MODACTIVE) || !is_user_connected(vIndex) )
		return

	if ( get_cvar_num("anibus_showdamage") )
	{
		new aIndex = get_user_attacker(vIndex)

		if ( aIndex <= 0 || aIndex > SH_MAXSLOTS || vIndex <= 0 || vIndex > SH_MAXSLOTS  || vIndex == aIndex )
			return

		new damage = read_data(2)

		if ( is_user_alive(aIndex) && g_hasAnubis[aIndex] )
		{
			set_hudmessage(0, 100, 200, -1.0, 0.55, 2, 0.1, 2.0, 0.02, 0.02, 74)
			show_hudmessage(aIndex, "%i", damage)
		}

		if ( is_user_alive(vIndex) && g_hasAnubis[vIndex] )
		{
			set_hudmessage(200, 0, 0, -1.0, 0.48, 2, 0.1, 2.0, 0.02, 0.02, 76)
			show_hudmessage(vIndex, "%i", damage)
		}
	}
}
//----------------------------------------------------------------------------------------------
public client_connect(id)
{
	g_hasAnubis[id] = false
}
//----------------------------------------------------------------------------------------------